'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var axios = require('axios');
var superjson = require('superjson');

function _interopDefault (e) { return e && e.__esModule ? e : { 'default': e }; }

var axios__default = /*#__PURE__*/_interopDefault(axios);

const defaults = axios__default['default'].defaults;
axios__default['default'].defaults.transformResponse = [superjson.parse];
async function request(param) {
  const response = await axios__default['default'](param); // For unit testing

  return response && response.data;
}
/**
 * @internal private api
 */

function createRequest(baseUrl, name) {
  return (...args) => {
    return request({
      url: getUrl(baseUrl, name),
      method: args.length === 0 ? 'GET' : 'POST',
      data: {
        args
      },
      meta: {}
    });
  };
}

function getUrl(baseUrl, name) {
  if (name === 'default') {
    return baseUrl;
  }

  if (baseUrl.endsWith('/')) {
    return `${baseUrl}${name}`;
  }

  return `${baseUrl}/${name}`;
}

exports.createRequest = createRequest;
exports.defaults = defaults;
exports.request = request;
