import axios from 'axios';
import { parse } from 'superjson';

const defaults = axios.defaults;
axios.defaults.transformResponse = [parse];
async function request(param) {
  const response = await axios(param); // For unit testing

  return response && response.data;
}
/**
 * @internal private api
 */

function createRequest(baseUrl, name) {
  return (...args) => {
    return request({
      url: getUrl(baseUrl, name),
      method: args.length === 0 ? 'GET' : 'POST',
      data: {
        args
      },
      meta: {}
    });
  };
}

function getUrl(baseUrl, name) {
  if (name === 'default') {
    return baseUrl;
  }

  if (baseUrl.endsWith('/')) {
    return `${baseUrl}${name}`;
  }

  return `${baseUrl}/${name}`;
}

export { createRequest, defaults, request };
